function [ betas, epsilon, r, it ] = ...
                        Mstep_mix(data, betas, resps, T, epsilon, r)

global PRM_MAC;

[Nsrc Nfeat] = size(betas);

cont = true;
it = 0;

% repeat m-step several times to account for cross-dependence of params
% like beta_{pg}, epsilon and r
while cont
    
    %remember old params to later decide whether to continue
    oldr = r;
    oldeps = epsilon;
    oldbetas = betas;
    
    if PRM_MAC.DetAnn.update_eps
        epsilon = ...
            update_mix_epsilon_bisect(resps, betas, r, data, T);
    end
    
    if PRM_MAC.DetAnn.update_r
        r = update_mix_r_bisect(resps, betas, epsilon, data, T);
    end
    
    for cla = 1 : Nsrc
        %select assignment-sets containing cluster p
        mylabelsetsInd = PRM_MAC.poss_assignments(:, cla) ==1;
        mylabelsets = PRM_MAC.poss_assignments( mylabelsetsInd , :);
        myresps = resps(:, mylabelsetsInd);
        clear mylabelsetsInd
        
        for dim = 1 : Nfeat
            betas(cla , dim) = update_mix_beta_newton(data,...
                myresps, mylabelsets, oldbetas, dim, cla, epsilon, r);
        end
        
    end
    
    it = it + 1;
    
    %stop at convergence
    abschange = abs(oldbetas - betas);
    cont = (max(max(abschange))>PRM_MAC.Mstep.changeTol) ...
        || any( abs(oldeps-epsilon)>PRM_MAC.Mstep.changeTol ) ...
        || any( abs(oldr-r)>PRM_MAC.Mstep.changeTol );
    cont = cont && it > 2*PRM_MAC.DetAnn.TfacItThresh;
        
end

end
